Index: codes/icosagcm/trunk/src/transfert_omp.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_omp.f90	(revision 294)
+++ codes/icosagcm/trunk/src/transfert_omp.f90	(revision 295)
@@ -34,5 +34,17 @@
   END INTERFACE 
 
-  PUBLIC bcast_omp, reduce_sum_omp, allreduce_sum_omp
+
+  INTERFACE reduce_max_omp
+    MODULE PROCEDURE reduce_max_omp_i,reduce_max_omp_i1,reduce_max_omp_i2,reduce_max_omp_i3,reduce_max_omp_i4, &
+                     reduce_max_omp_r,reduce_max_omp_r1,reduce_max_omp_r2,reduce_max_omp_r3,reduce_max_omp_r4
+  END INTERFACE 
+
+  INTERFACE allreduce_max_omp
+    MODULE PROCEDURE allreduce_max_omp_i,allreduce_max_omp_i1,allreduce_max_omp_i2,allreduce_max_omp_i3,allreduce_max_omp_i4, &
+                     allreduce_max_omp_r,allreduce_max_omp_r1,allreduce_max_omp_r2,allreduce_max_omp_r3,allreduce_max_omp_r4
+  END INTERFACE 
+
+
+  PUBLIC bcast_omp, reduce_sum_omp, allreduce_sum_omp, reduce_max_omp, allreduce_max_omp
   
 CONTAINS
@@ -521,4 +533,268 @@
   END SUBROUTINE allreduce_sum_omp_r4  
   
+
+
+
+
+
+
+
+
+
+
+
+  SUBROUTINE reduce_max_omp_i(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN)  :: VarIn
+    INTEGER,INTENT(OUT) :: VarOut
+    INTEGER             :: VarIn_tmp(1)
+    INTEGER             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_i(1)   
+    CALL reduce_max_omp_igen(VarIn_tmp,Varout_tmp,1,buffer_i)
+    VarOut=VarOut_tmp(1)
+    
+  END SUBROUTINE reduce_max_omp_i
+
+  SUBROUTINE reduce_max_omp_i1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+   
+  END SUBROUTINE reduce_max_omp_i1
+  
+  
+  SUBROUTINE reduce_max_omp_i2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
+
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_max_omp_i2
+
+
+  SUBROUTINE reduce_max_omp_i3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_max_omp_i3
+
+
+  SUBROUTINE reduce_max_omp_i4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE reduce_max_omp_i4
+
+
+  SUBROUTINE reduce_max_omp_r(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN)  :: VarIn
+    REAL,INTENT(OUT) :: VarOut
+    REAL             :: VarIn_tmp(1)
+    REAL             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_r(1)   
+    CALL reduce_max_omp_rgen(VarIn_tmp,Varout_tmp,1,buffer_r)
+    VarOut=VarOut_tmp(1)
+  
+  END SUBROUTINE reduce_max_omp_r
+
+  SUBROUTINE reduce_max_omp_r1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+   
+  END SUBROUTINE reduce_max_omp_r1
+  
+  
+  SUBROUTINE reduce_max_omp_r2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_max_omp_r2
+
+
+  SUBROUTINE reduce_max_omp_r3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_max_omp_r3
+
+
+  SUBROUTINE reduce_max_omp_r4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    REAL,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE reduce_max_omp_r4  
+  
+  
+  
+  
+    SUBROUTINE allreduce_max_omp_i(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN)  :: VarIn
+    INTEGER,INTENT(OUT) :: VarOut
+    INTEGER             :: VarIn_tmp(1)
+    INTEGER             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_i(1)   
+    CALL allreduce_max_omp_igen(VarIn_tmp,Varout_tmp,1,buffer_i)
+    VarOut=VarOut_tmp(1)
+    
+  END SUBROUTINE allreduce_max_omp_i
+
+  SUBROUTINE allreduce_max_omp_i1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL allreduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+   
+  END SUBROUTINE allreduce_max_omp_i1
+  
+  
+  SUBROUTINE allreduce_max_omp_i2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
+
+    CALL Check_buffer_i(size(VarIn))   
+    CALL allreduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE allreduce_max_omp_i2
+
+
+  SUBROUTINE allreduce_max_omp_i3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    INTEGER,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_i(size(VarIn))   
+    CALL allreduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE allreduce_max_omp_i3
+
+
+  SUBROUTINE allreduce_max_omp_i4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    INTEGER,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_i(size(VarIn))   
+    CALL allreduce_max_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
+  
+  END SUBROUTINE allreduce_max_omp_i4
+
+
+  SUBROUTINE allreduce_max_omp_r(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN)  :: VarIn
+    REAL,INTENT(OUT) :: VarOut
+    REAL             :: VarIn_tmp(1)
+    REAL             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_r(1)   
+    CALL allreduce_max_omp_rgen(VarIn_tmp,Varout_tmp,1,buffer_r)
+    VarOut=VarOut_tmp(1)
+  
+  END SUBROUTINE allreduce_max_omp_r
+
+  SUBROUTINE allreduce_max_omp_r1(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL allreduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+   
+  END SUBROUTINE allreduce_max_omp_r1
+  
+  
+  SUBROUTINE allreduce_max_omp_r2(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL allreduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE allreduce_max_omp_r2
+
+
+  SUBROUTINE allreduce_max_omp_r3(VarIn, VarOut)
+    IMPLICIT NONE
+  
+    REAL,INTENT(IN),DIMENSION(:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
+    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL allreduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE allreduce_max_omp_r3
+
+
+  SUBROUTINE allreduce_max_omp_r4(VarIn, VarOut)
+    IMPLICIT NONE
+
+    REAL,INTENT(IN),DIMENSION(:,:,:,:)  :: VarIn
+    REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
+  
+    CALL Check_buffer_r(size(VarIn))   
+    CALL allreduce_max_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
+  
+  END SUBROUTINE allreduce_max_omp_r4  
+
   
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -740,4 +1016,141 @@
   
   END SUBROUTINE allreduce_sum_omp_rgen
+
+
+
+
+
+
+  SUBROUTINE reduce_max_omp_igen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    INTEGER,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    INTEGER,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+
+  !$OMP MASTER
+    Buff(:)=VarIn(1)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MAX(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+  !$OMP MASTER
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  END SUBROUTINE reduce_max_omp_igen
+
+  SUBROUTINE reduce_max_omp_rgen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    REAL,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    REAL,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+
+  !$OMP MASTER
+    Buff(:)=VarIn(1)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MAX(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+  !$OMP BARRIER
+  
+  END SUBROUTINE reduce_max_omp_rgen
+
+
+
+  SUBROUTINE allreduce_max_omp_igen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    INTEGER,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    INTEGER,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    INTEGER,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+
+  !$OMP MASTER
+    Buff(:)=VarIn(1)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MAX(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+  !$OMP BARRIER
+  
+  END SUBROUTINE allreduce_max_omp_igen
+
+  SUBROUTINE allreduce_max_omp_rgen(VarIn,VarOut,dimsize,Buff)
+  IMPLICIT NONE
+
+    INTEGER,INTENT(IN) :: dimsize
+    REAL,INTENT(IN),DIMENSION(dimsize) :: VarIn
+    REAL,INTENT(OUT),DIMENSION(dimsize) :: VarOut
+    REAL,INTENT(INOUT),DIMENSION(dimsize) :: Buff
+
+    INTEGER :: i
+
+  !$OMP MASTER
+    Buff(:)=VarIn(1)
+  !$OMP END MASTER
+  !$OMP BARRIER
+  
+  !$OMP CRITICAL     
+    DO i=1,dimsize
+      Buff(i)=MAX(Buff(i),VarIn(i))
+    ENDDO
+  !$OMP END CRITICAL
+  !$OMP BARRIER  
+  
+    DO i=1,dimsize
+      VarOut(i)=Buff(i)
+    ENDDO
+
+  !$OMP BARRIER
+  
+  END SUBROUTINE allreduce_max_omp_rgen
+    
+
+
+
+
+
+
+
+
+
+
     
 END MODULE transfert_omp_mod
Index: codes/icosagcm/trunk/src/vertical_interp.f90
===================================================================
--- codes/icosagcm/trunk/src/vertical_interp.f90	(revision 294)
+++ codes/icosagcm/trunk/src/vertical_interp.f90	(revision 295)
@@ -21,4 +21,5 @@
   USE icosa
   USE pression_mod
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -48,4 +49,5 @@
 
   SUBROUTINE compute_vertical_interp(p,in,out,pval)
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN) :: p(iim*jjm,llm+1)
@@ -56,19 +58,25 @@
     INTEGER :: i,j,ij,l
         
-    DO j=jj_begin-1,jj_end+1
-      DO i=ii_begin-1,ii_end+1
-        ij=(j-1)*iim+i
-        l=llm-1
-        DO WHILE(0.5*(p(ij,l)+p(ij,l+1))<pval .AND. l>1)
-          l=l-1
+!$OMP BARRIER    
+    IF (is_omp_level_master) THEN
+    
+      DO j=jj_begin-1,jj_end+1
+        DO i=ii_begin-1,ii_end+1
+          ij=(j-1)*iim+i
+          l=llm-1
+          DO WHILE(0.5*(p(ij,l)+p(ij,l+1))<pval .AND. l>1)
+            l=l-1
+          ENDDO
+          pmid=0.5*(p(ij,l)+p(ij,l+1))
+          pmidp1=0.5*(p(ij,l+1)+p(ij,l+2))
+
+          coeff=(pval-pmid)/(pmid-pmidp1)
+        
+          out(ij)=in(ij,l)+coeff*(in(ij,l)-in(ij,l+1))
         ENDDO
-        pmid=0.5*(p(ij,l)+p(ij,l+1))
-        pmidp1=0.5*(p(ij,l+1)+p(ij,l+2))
-
-        coeff=(pval-pmid)/(pmid-pmidp1)
-        
-        out(ij)=in(ij,l)+coeff*(in(ij,l)-in(ij,l+1))
       ENDDO
-    ENDDO
+   
+    ENDIF
+!$OMP BARRIER    
         
   END SUBROUTINE compute_vertical_interp
Index: codes/icosagcm/trunk/src/vorticity.f90
===================================================================
--- codes/icosagcm/trunk/src/vorticity.f90	(revision 294)
+++ codes/icosagcm/trunk/src/vorticity.f90	(revision 295)
@@ -29,4 +29,5 @@
   USE icosa
   USE disvert_mod
+  USE omp_para
   IMPLICIT NONE
     REAL(rstd),INTENT(IN)  :: ue(3*iim*jjm,llm)
@@ -34,5 +35,5 @@
     INTEGER :: i,j,ij,l
 
-    DO l = 1,llm
+    DO l = ll_begin,ll_end
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
Index: codes/icosagcm/trunk/src/wind.f90
===================================================================
--- codes/icosagcm/trunk/src/wind.f90	(revision 294)
+++ codes/icosagcm/trunk/src/wind.f90	(revision 295)
@@ -47,5 +47,5 @@
   SUBROUTINE compute_wind_centered(ue,ucenter)
   USE icosa
-  
+  USE omp_para
   IMPLICIT NONE
   REAL(rstd) :: ue(3*iim*jjm,llm)
@@ -53,5 +53,5 @@
   INTEGER :: i,j,ij,l    
  
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -73,4 +73,5 @@
  SUBROUTINE compute_wind_on_edge(ue,uedge)
   USE icosa
+  USE omp_para
     
   IMPLICIT NONE
@@ -83,5 +84,5 @@
     CALL compute_tangential_compound(ue,ut)
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -100,4 +101,5 @@
  SUBROUTINE compute_tangential_compound(ue,ut)
   USE icosa  
+  USE omp_para
   IMPLICIT NONE
   REAL(rstd) :: ue(3*iim*jjm,llm)
@@ -105,5 +107,5 @@
   INTEGER :: i,j,l,ij
     
-  DO l=1,llm
+  DO l=ll_begin,ll_end
     DO j=jj_begin,jj_end
       DO i=ii_begin,ii_end
@@ -155,4 +157,5 @@
  SUBROUTINE compute_wind_lonlat_compound(u, ulon, ulat)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -164,5 +167,5 @@
     
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -184,4 +187,5 @@
   SUBROUTINE compute_wind_from_lonlat_compound(ulon, ulat, u)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -192,5 +196,5 @@
   INTEGER :: i,j,ij,l     
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -207,4 +211,5 @@
   SUBROUTINE compute_wind_centered_from_lonlat_compound(ulon, ulat, u)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -214,5 +219,5 @@
 
   INTEGER :: i,j,ij,l     
-  DO l=1,llm
+  DO l=ll_begin,ll_end
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -248,4 +253,5 @@
   SUBROUTINE compute_wind_perp_from_lonlat_compound(ulon, ulat, up)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -259,5 +265,5 @@
    CALL compute_wind_from_lonlat_compound(ulon, ulat, u)
 
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin-1,jj_end+1
         DO i=ii_begin-1,ii_end+1
@@ -297,4 +303,5 @@
  SUBROUTINE compute_wind_centered_lonlat_compound(uc, ulon, ulat)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -306,5 +313,5 @@
     
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -320,4 +327,5 @@
  SUBROUTINE compute_wind_centered_from_wind_lonlat_centered(ulon, ulat,uc)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -329,5 +337,5 @@
     
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -344,4 +352,5 @@
  SUBROUTINE compute_wind_perp_from_wind_centered(uc,un)
   USE icosa  
+  USE omp_para
     
   IMPLICIT NONE
@@ -352,5 +361,5 @@
     
   
-    DO l=1,llm
+    DO l=ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
